﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;

namespace ImplementAPI.Controllers
{
    public class APIController : ApiController
    {
        public IEnumerable<Product> GetAllProducts()
        {
            using (var context = new Entities())
            {
                var record = context.Products.Select(x => x).ToArray();
                return record;
            }
        }

        public IHttpActionResult GetProduct(int id)
        {
            if (!Authenticate())
                return ResponseMessage(new HttpResponseMessage(HttpStatusCode.Forbidden));
            using (var context = new Entities())
            {
                var totalRecords = context.Products.Count();
                var pageSize = 10;
                var skip = pageSize * (id - 1);
                var canPage = skip < totalRecords;

                IEnumerable<Product> record = null;
                if (canPage)
                {
                    record = context.Products
                             .OrderBy(x => x.ProductID)
                             .Skip(skip)
                             .Take(pageSize)
                             .ToArray();
                }
                var output = new { Total = totalRecords, CurrentPage = id, PageSize = pageSize, Product = record };
                return Ok(output);
            }
        }

        [HttpPost]
        public IHttpActionResult SearchProduct(string id)
        {
            if (!Authenticate())
                return ResponseMessage(new HttpResponseMessage(HttpStatusCode.Forbidden));

            using (var context = new Entities())
            {
                var record = context.Products.Where(x => x.ProductName == id).ToArray();
                var output = new { Product = record };
                return Ok(output);
            }
        }

        bool Authenticate()
        {
            var APICrendential = new[] { new { Key = "Key1", Secret = "Secret1" }, new { Key = "Key2", Secret = "Secret2" }, new { Key = "Key3", Secret = "Secret3" } };

            System.Net.Http.Headers.HttpRequestHeaders headers = Request.Headers;
            string key = "", secret = "";
            if (headers.Contains("Key"))
                key = headers.GetValues("Key").First();
            if (headers.Contains("Secret"))
                secret = headers.GetValues("Secret").First();

            int count = (from t in APICrendential where t.Key == key && t.Secret == secret select t).Count();
            return count == 0 ? false : true;
        }
    }
}
